/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

divides(X,X).
divides(X,Y):-
  X>0, Y>0,
  D is Y-X,
  divides(X,D).


divides(X,X,1).
divides(X,Y,N):-
  X>0, Y>0,
  D is Y-X,
  divides(X,D,N1),
  N is N+1.